;------------------------------------------------------------------------
;                                                                       |
;   FILE        :sfr_r827.inc                                           |
;   DATE        :Wed, Apr 11, 2012                                      |
;   DESCRIPTION :define the sfr register. (for Assembler language)      |
;   CPU GROUP   :27                                                     |
;                                                                       |
;   This file is generated by Renesas Project Generator (Ver.4.18).     |
;   NOTE:THIS IS A TYPICAL EXAMPLE.                                     |
;------------------------------------------------------------------------
;************************************************************************************
;*																					*
;*	File name	: SFR_R827.inc														*
;*	Contents	: definition of R8C/26 & R8C/27 Group SFR							*
;*	Copyright (C) 2006 (2010) Renesas Electronics Corporation. All rights reserved.	*
;*	Version		: 1.00 (06-02-02)													*
;*	note		:																	*
;*																					*
;************************************************************************************
;
;-------------------------------------------------------
;   Processor mode register0
;-------------------------------------------------------
pm0				.equ		0004h
;
pm03			.btequ		3,pm0		; Software reset bit
;
;-------------------------------------------------------
;   Processor mode register1
;-------------------------------------------------------
pm1				.equ		0005h
;
pm12			.btequ		2,pm1		; WDT interrupt/reset select bit
;
;-------------------------------------------------------
;   System clock control register0
;-------------------------------------------------------
cm0				.equ		0006h
;
cm01			.btequ		1,cm0		; Clock output function select bit
cm02			.btequ		2,cm0		; WAIT peripheral function clock stop bit
cm03			.btequ		3,cm0		; Xcin-Xcout drive capacity select bit
cm04			.btequ		4,cm0		; Xcin clock (Xcin-Xcout) start bit
cm05			.btequ		5,cm0		; Xin clock (Xin-Xout) stop bit
cm06			.btequ		6,cm0		; System clock division select bit0
;
;-------------------------------------------------------
;   System clock control register1
;-------------------------------------------------------
cm1				.equ		0007h
;	
cm10			.btequ		0,cm1		; All clock stop control bit
cm11			.btequ		1,cm1		; XIN-XOUT internal resistor select bit
cm12			.btequ		2,cm1		; XCIN-XCOUT internal resistor select bit
cm13			.btequ		3,cm1		; Port Xin-Xout switch bit
cm14			.btequ		4,cm1		; Low-speed on-chip oscillator stop bit
cm15			.btequ		5,cm1		; Xin-Xout drive capability select bit
cm16			.btequ		6,cm1		; System clock division select bit1
cm17			.btequ		7,cm1		;
;
;-------------------------------------------------------
;   Protect register
;-------------------------------------------------------
prcr			.equ		000ah
;
prc0			.btequ		0,prcr		; Protect bit0
prc1			.btequ		1,prcr		; Protect bit1
prc2			.btequ		2,prcr		; Protect bit2
prc3			.btequ		3,prcr		; Protect bit3
;
;-------------------------------------------------------
;   Oscillation stop detection register
;-------------------------------------------------------
ocd				.equ		000ch
;
ocd0			.btequ		0,ocd		; Oscillation stop detection enable bit
ocd1			.btequ		1,ocd		; Oscillation stop detection interrupt enable bit
ocd2			.btequ		2,ocd		; System clock select bit
ocd3			.btequ		3,ocd		; Clock monitor bit
;
;-------------------------------------------------------
;   Watchdog timer
;-------------------------------------------------------
wdtr			.equ		000dh		; Watchdog timer reset register
;
wdts			.equ		000eh		; Watchdog timer start register
;
wdc				.equ		000fh		; Watchdog timer control register
;
wdc7			.btequ		7,wdc		; Prescaler select bit
;
;-------------------------------------------------------
;   Address match interrupt register0
;-------------------------------------------------------
rmad0			.equ		0010h
rmad0l			.equ		rmad0		; Address match interrupt register0 Low
rmad0m			.equ		rmad0+1		; Address match interrupt register0 Middle
rmad0h			.equ		rmad0+2		; Address match interrupt register0 High
;

;-------------------------------------------------------
;   Address match interrupt enable register
;-------------------------------------------------------
aier			.equ		0013h
;
aier0			.btequ		0,aier		; Address match interrupt 0 enable bit
aier1			.btequ		1,aier		; Address match interrupt 1 enable bit
;

;-------------------------------------------------------
;   Address match interrupt register1
;-------------------------------------------------------
rmad1			.equ		0014h
rmad1l			.equ		rmad1		; Address match interrupt register1 Low
rmad1m			.equ		rmad1+1		; Address match interrupt register1 Middle
rmad1h			.equ		rmad1+2		; Address match interrupt register1 High
;
;-------------------------------------------------------
;   Count source protect mode register
;-------------------------------------------------------
cspr			.equ		001ch
;
cspro			.btequ		7,cspr		; WDT count source protect mode select bit
;
;-------------------------------------------------------
;   High-speed on-chip oscillator control register0
;-------------------------------------------------------
fra0			.equ		0023h
;
fra00			.btequ		0,fra0		; High-speed on-chip oscillator enable bit
fra01			.btequ		1,fra0		; High-speed on-chip oscillator select bit
;
;-------------------------------------------------------
;   High-speed on-chip oscillator control register1
;-------------------------------------------------------
fra1			.equ		0024h
;
;-------------------------------------------------------
;   High-speed on-chip oscillator control register2
;-------------------------------------------------------
fra2			.equ		0025h
;
fra20			.btequ		0,fra2		; High-speed on-chip oscillator frequency switching bit
fra21			.btequ		1,fra2		; High-speed on-chip oscillator frequency switching bit
fra22			.btequ		2,fra2		; High-speed on-chip oscillator frequency switching bit
;
;-------------------------------------------------------
;	Clock prescaler reset flag
;-------------------------------------------------------
cpsrf			.equ		0028h
;
cpsr			.btequ		7,cpsrf		; Clock prescaler reset flag
;
;-------------------------------------------------------
;   Voltage detection register1
;-------------------------------------------------------
vca1			.equ		0031h
;
vca13			.btequ		3,vca1		; Voltage detection 2 signal monitor flag
;
;-------------------------------------------------------
;   Voltage detection register2
;-------------------------------------------------------
vca2			.equ		0032h
;
vca20			.btequ		0,vca2		; Internal power supply low power consumption enable bit
vca25			.btequ		5,vca2		; Voltage detection 0 enable bit
vca26			.btequ		6,vca2		; Voltage detection 1 enable bit
vca27			.btequ		7,vca2		; Voltage detection 2 enable bit
;
;-------------------------------------------------------
;   Voltage monitor 1 circuit control register
;-------------------------------------------------------
vw1c			.equ		0036h
;
vw1c0			.btequ		0,vw1c		; Voltage monitor 1 interrupt / reset enable bit
vw1c1			.btequ		1,vw1c		; Voltage Monitor 1 digital filter disable mode select bit
vw1c2			.btequ		2,vw1c		; Voltage change detection flag
vw1c3			.btequ		3,vw1c		; Voltage detection 1 signal monitor flag
vw1f0			.btequ		4,vw1c		; Sampling clock select bit
vw1f1			.btequ		5,vw1c		; Sampling clock select bit
vw1c6			.btequ		6,vw1c		; Voltage monitor 1 circuit mode select bit
vw1c7			.btequ		7,vw1c		; Voltage monitor 1 interrupt / reset generating condition select bit
;
;-------------------------------------------------------
;   Voltage monitor 2 circuit control register
;-------------------------------------------------------
vw2c			.equ		0037h
;
vw2c0			.btequ		0,vw2c		; Voltage monitor 2 interrupt / reset enable bit
vw2c1			.btequ		1,vw2c		; Voltage monitor 2 digital filter disabled mode select bit
vw2c2			.btequ		2,vw2c		; Voltage change detection flag
vw2c3			.btequ		3,vw2c		; WDT Detection Flag
vw2f0			.btequ		4,vw2c		; Sampling clock select bit
vw2f1			.btequ		5,vw2c		; Sampling clock select bit
vw2c6			.btequ		6,vw2c		; Voltage monitor 2 circuit mode select bit
vw2c7			.btequ		7,vw2c		; Voltage monitor 2 interrupt / reset generating condition select bit
;                                     
;-------------------------------------------------------
;   Voltage monitor 0 circuit control register
;-------------------------------------------------------
vw0c			.equ		0038h

vw0c0			.btequ		0,vw0c		; Voltage monitor 0 reset enable bit
vw0c1			.btequ		1,vw0c		; Voltage Monitor 0 digital filter disable mode select bit
vw0c2			.btequ		2,vw0c		;
vw0f0			.btequ		4,vw0c		; Sampling clock select bit
vw0f1			.btequ		5,vw0c		; Sampling clock select bit
vw0c6			.btequ		6,vw0c		; Voltage monitor 0 circuit mode select bit
vw0c7			.btequ		7,vw0c		; Voltage monitor 0 reset generating condition select bit
;
;-------------------------------------------------------
;   Interrupt control registers
;-------------------------------------------------------
trcic			.equ		0047h		; Timer RC interrupt control register
ilvl0_trcic		.btequ		0,trcic		; Interrupt priority level select bit
ilvl1_trcic		.btequ		1,trcic		;
ilvl2_trcic		.btequ		2,trcic		;
ir_trcic		.btequ		3,trcic		; Interrupt request bit
;
treic			.equ		004Ah		; Timer RE interrupt control register
ilvl0_treic		.btequ		0,treic		; Interrupt priority level select bit
ilvl1_treic		.btequ		1,treic		;
ilvl2_treic		.btequ		2,treic		;
ir_treic		.btequ		3,treic		; Interrupt request bit
;
kupic			.equ		004dh		; Key input interrupt control register
ilvl0_kupic		.btequ		0,kupic		; Interrupt priority level select bit
ilvl1_kupic		.btequ		1,kupic		;
ilvl2_kupic		.btequ		2,kupic		;
ir_kupic		.btequ		3,kupic		; Interrupt request bit
;
adic			.equ		004eh		; A-D conversion interrupt control register
ilvl0_adic		.btequ		0,adic		; Interrupt priority level select bit
ilvl1_adic		.btequ		1,adic		;
ilvl2_adic		.btequ		2,adic		;
ir_adic			.btequ		3,adic		; Interrupt request bit
;
ssuic			.equ		004fh		; SSU interrupt control register
ilvl0_ssuic		.btequ		0,ssuic		; Interrupt priority level select bit
ilvl1_ssuic		.btequ		1,ssuic		;
ilvl2_ssuic		.btequ		2,ssuic		;
ir_ssuic		.btequ		3,ssuic		; Interrupt request bit
;
iicic			.equ		004fh		; IIC interrupt control register
ilvl0_iicic		.btequ		0,iicic		; Interrupt priority level select bit
ilvl1_iicic		.btequ		1,iicic		;
ilvl2_iicic		.btequ		2,iicic		;
ir_iicic		.btequ		3,iicic		; Interrupt request bit
;
s0tic			.equ		0051h		; UART0 transmit interrupt control register
ilvl0_s0tic		.btequ		0,s0tic		; Interrupt priority level select bit
ilvl1_s0tic		.btequ		1,s0tic		;
ilvl2_s0tic		.btequ		2,s0tic		;
ir_s0tic		.btequ		3,s0tic		; Interrupt request bit
;
s0ric			.equ		0052h		; UART0 receive interrupt control register
ilvl0_s0ric		.btequ		0,s0ric		; Interrupt priority level select bit
ilvl1_s0ric		.btequ		1,s0ric		;
ilvl2_s0ric		.btequ		2,s0ric		;
ir_s0ric		.btequ		3,s0ric		; Interrupt request bit
;
s1tic			.equ		0053h		; UART1 transmit interrupt control register
ilvl0_s1tic		.btequ		0,s1tic		; Interrupt priority level select bit
ilvl1_s1tic		.btequ		1,s1tic		;
ilvl2_s1tic		.btequ		2,s1tic		;
ir_s1tic		.btequ		3,s1tic		; Interrupt request bit
;
s1ric			.equ		0054h		; UART1 receive interrupt control register
ilvl0_s1ric		.btequ		0,s1ric		; Interrupt priority level select bit
ilvl1_s1ric		.btequ		1,s1ric		;
ilvl2_s1ric		.btequ		2,s1ric		;
ir_s1ric		.btequ		3,s1ric		; Interrupt request bit
;
traic			.equ		0056h		; Timer RA interrupt control register
ilvl0_traic		.btequ		0,traic		; Interrupt priority level select bit
ilvl1_traic		.btequ		1,traic		;
ilvl2_traic		.btequ		2,traic		;
ir_traic		.btequ		3,traic		; Interrupt request bit
;
trbic			.equ		0058h		; Timer RB interrupt control register
ilvl0_trbic		.btequ		0,trbic		; Interrupt priority level select bit
ilvl1_trbic		.btequ		1,trbic		;
ilvl2_trbic		.btequ		2,trbic		;
ir_trbic		.btequ		3,trbic		; Interrupt request bit
;
int1ic			.equ		0059h		; INT1 interrupt control register
ilvl0_int1ic	.btequ		0,int1ic	; Interrupt priority level select bit
ilvl1_int1ic	.btequ		1,int1ic	;
ilvl2_int1ic	.btequ		2,int1ic	;
ir_int1ic		.btequ		3,int1ic	; Interrupt request bit
pol_int1ic		.btequ		4,int1ic	; Polarity select bit
;
int3ic			.equ		005ah		; INT3 interrupt control register
ilvl0_int3ic	.btequ		0,int3ic	; Interrupt priority level select bit
ilvl1_int3ic	.btequ		1,int3ic	;
ilvl2_int3ic	.btequ		2,int3ic	;
ir_int3ic		.btequ		3,int3ic	; Interrupt request bit
pol_int3ic		.btequ		4,int3ic	; Polarity select bit
;
int0ic			.equ		005dh		; INT0 interrupt control register
ilvl0_int0ic	.btequ		0,int0ic	; Interrupt priority level select bit
ilvl1_int0ic	.btequ		1,int0ic	;
ilvl2_int0ic	.btequ		2,int0ic	;
ir_int0ic		.btequ		3,int0ic	; Interrupt request bit
pol_int0ic		.btequ		4,int0ic	; Polarity select bit
;
;-------------------------------------------------------
;   UART0
;-------------------------------------------------------
u0mr			.equ		00a0h		; UART0 transmit/receive mode register
smd0_u0mr		.btequ		0,u0mr		; Serial I/O mode select bit
smd1_u0mr		.btequ		1,u0mr		;
smd2_u0mr		.btequ		2,u0mr		;
ckdir_u0mr		.btequ		3,u0mr		; Internal/external clock select bit
stps_u0mr		.btequ		4,u0mr		; Stop bit length select bit
pry_u0mr		.btequ		5,u0mr		; Odd/even parity select bit
prye_u0mr		.btequ		6,u0mr		; Parity enable bit
;
u0brg			.equ		00a1h		; UART0 bit rate register ; Use "MOV" instruction when writing to this register.
;
u0tb			.equ		00a2h		; UART0 transmit buffer register ; Use "MOV" instruction when writing to this register.
u0tbl			.equ		u0tb		;       Low
u0tbh			.equ		u0tb+1		;       High
;
u0c0			.equ		00a4h		; UART0 transmit/receive control register0
clk0_u0c0		.btequ		0,u0c0		; BRG count source select bit
clk1_u0c0		.btequ		1,u0c0		;
txept_u0c0		.btequ		3,u0c0		; Transmit register empty flag
nch_u0c0		.btequ		5,u0c0		; Data output select bit
ckpol_u0c0		.btequ		6,u0c0		; CLK polarity select bit
uform_u0c0		.btequ		7,u0c0		; Transfer format select bit
;
u0c1			.equ		00a5h		; UART0 transmit/receive control register1
te_u0c1			.btequ		0,u0c1		; Transmit enable bit
ti_u0c1			.btequ		1,u0c1		; Transmit buffer empty flag
re_u0c1			.btequ		2,u0c1		; Receive enable bit
ri_u0c1			.btequ		3,u0c1		; Receive complete flag
u0irs_u0c1		.btequ		4,u0c1		; UART0 transmit interrupt cause select bit
u0rrm_u0c1		.btequ		5,u0c1		; UART0 continuous receive mode enable bit
;
u0rb			.equ		00a6h		; UART0 receive buffer register
u0rbl			.equ		u0rb        ;       Low
u0rbh			.equ		u0rb+1		;       High
oer_u0rb		.btequ		4,u0rbh		; Overrun error flag
fer_u0rb		.btequ		5,u0rbh		; Framing error flag
per_u0rb		.btequ		6,u0rbh		; Parity error flag
sum_u0rb		.btequ		7,u0rbh		; Error sum flag
;
u1mr			.equ		00a8h		; UART1 transmit/receive mode register
smd0_u1mr		.btequ		0,u1mr		; Serial I/O mode select bit
smd1_u1mr		.btequ		1,u1mr		;
smd2_u1mr		.btequ		2,u1mr		;
ckdir_u1mr		.btequ		3,u1mr		; Internal/external clock select bit
stps_u1mr		.btequ		4,u1mr		; Stop bit length select bit
pry_u1mr		.btequ		5,u1mr		; Odd/even parity select bit
prye_u1mr		.btequ		6,u1mr		; Parity enable bit
;
u1brg			.equ		00a9h		; UART1 bit rate register ; Use "MOV" instruction when writing to this register.
;
u1tb			.equ		00aah		; UART1 transmit buffer register ; Use "MOV" instruction when writing to this register.
u1tbl			.equ		u1tb		;       Low
u1tbh			.equ		u1tb+1		;       High
;
u1c0			.equ		00ach		; UART1 transmit/receive control register0
clk0_u1c0		.btequ		0,u1c0		; BRG count source select bit
clk1_u1c0		.btequ		1,u1c0		;
txept_u1c0		.btequ		3,u1c0		; Transmit register empty flag
nch_u1c0		.btequ		5,u1c0		; Data output select bit
ckpol_u1c0		.btequ		6,u1c0		; CLK polarity select bit
uform_u1c0		.btequ		7,u1c0		; Transfer format select bit
;
u1c1			.equ		00adh		; UART1 transmit/receive control register1
te_u1c1			.btequ		0,u1c1		; Transmit enable bit
ti_u1c1			.btequ		1,u1c1		; Transmit buffer empty flag
re_u1c1			.btequ		2,u1c1		; Receive enable bit
ri_u1c1			.btequ		3,u1c1		; Receive complete flag
u1irs_u1c1		.btequ		4,u1c1		; UART1 transmit interrupt cause select bit
u1rrm_u1c1		.btequ		5,u1c1		; UART1 continuous receive mode enable bit
;
u1rb			.equ		00aeh		; UART1 receive buffer register
u1rbl			.equ		u1rb        ;       Low
u1rbh			.equ		u1rb+1		;       High
oer_u1rb		.btequ		4,u1rbh		; Overrun error flag
fer_u1rb		.btequ		5,u1rbh		; Framing error flag
per_u1rb		.btequ		6,u1rbh		; Parity error flag
sum_u1rb		.btequ		7,u1rbh		; Error sum flag
;
;-------------------------------------------------------
;   SS control register H
;-------------------------------------------------------
sscrh			.equ		00b8h
;
cks0_sscrh		.btequ		0,sscrh		; Transfer clock rate select bit
cks1_sscrh		.btequ		1,sscrh		; 
cks2_sscrh		.btequ		2,sscrh		; 
mss_sscrh		.btequ		5,sscrh		; Master/Slave device select bit
rsstp_sscrh		.btequ		6,sscrh		; Receive single stop bit 
;
;-------------------------------------------------------
;   IIC bus control register 1
;-------------------------------------------------------
iccr1			.equ		00b8h
;
cks0_iccr1		.btequ		0,iccr1		; Transmit clock select bit 3 to 0
cks1_iccr1		.btequ		1,iccr1		; 
cks2_iccr1		.btequ		2,iccr1		; 
cks3_iccr1		.btequ		3,iccr1		; 
trs_iccr1		.btequ		4,iccr1		; Transfer/Receive select bit
mst_iccr1		.btequ		5,iccr1		; Master/Slave select bit
rcvd_iccr1		.btequ		6,iccr1		; Receive disable bit
ice_iccr1		.btequ		7,iccr1		; IIC bus interface 2A enable bit
;
;-------------------------------------------------------
;   SS control register L
;-------------------------------------------------------
sscrl			.equ		00b9h
;
sres_sscrl		.btequ		1,sscrl		; SSUA control part reset bit
solp_sscrl		.btequ		4,sscrl		; SOL write protect bit
sol_sscrl		.btequ		5,sscrl		; Serial data output value setting bit
;
;-------------------------------------------------------
;   IIC bus control register 2
;-------------------------------------------------------
iccr2			.equ		00b9h
;
iicrst_iccr2	.btequ		1,iccr2		; IIC control part reset bit
sclo_iccr2		.btequ		3,iccr2		; SCL monitor flag
sdaop_iccr2		.btequ		4,iccr2		; SDAO write protect bit
sdao_iccr2		.btequ		5,iccr2		; SDA output value control bit
scp_iccr2		.btequ		6,iccr2		; Start/Stop condition generation disable bit
bbsy_iccr2		.btequ		7,iccr2		; Bus busy bit
;
;-------------------------------------------------------
;   SS mode register 
;-------------------------------------------------------
ssmr			.equ		00bah
;
bc0_ssmr	    .btequ		0,ssmr		; Bit counter 2 to 0
bc1_ssmr		.btequ		1,ssmr		; 
bc2_ssmr		.btequ		2,ssmr		; 
cphs_ssmr		.btequ		5,ssmr		; SSCK clock phase select bit 
cpos_ssmr		.btequ		6,ssmr		; SSCK clock polarity select bit 
mls_ssmr		.btequ		7,ssmr		; MSB first/ LSB first select bit 
;
;-------------------------------------------------------
;   IIC bus mode register
;-------------------------------------------------------
icmr			.equ		00bah
;
bc0_icmr	    .btequ		0,icmr		; Bit counter 2 to 0
bc1_icmr		.btequ		1,icmr		; 
bc2_icmr		.btequ		2,icmr		; 
bcwp_icmr		.btequ		3,icmr		; BC write protect bit
wait_icmr		.btequ		6,icmr		; Wait insertion bit
mls_icmr		.btequ		7,icmr		; MSB-First/LSB-First select
;
;-------------------------------------------------------
;   SS enable register 
;-------------------------------------------------------
sser			.equ		00bbh
;
ceie_sser		.btequ		0,sser		; Conflict error interrupt enable bit 
re_sser			.btequ		3,sser		; Receive enable bit 
te_sser			.btequ		4,sser		; Transmit enable bit
rie_sser		.btequ		5,sser		; Receive interrupt enable bit 
teie_sser		.btequ		6,sser		; Transmit end interrupt enable bit 
tie_sser		.btequ		7,sser		; Transmit interrupt enable bit 
;
;-------------------------------------------------------
;   IIC bus interrupt enable register
;-------------------------------------------------------
icier			.equ		00bbh
;
ackbt_icier		.btequ		0,icier		; Transmit acknowledge select bit
ackbr_icier		.btequ		1,icier		; Receive acknowledge bit
acke_icier		.btequ		2,icier		; Acknowledge bit judgement select bit
stie_icier		.btequ		3,icier		; Stop condition detection interrupt enable bit
nakie_icier		.btequ		4,icier		; NACK receive interrupt enable bit
rie_icier		.btequ		5,icier		; Receive interrupt enable bit
teie_icier		.btequ		6,icier		; Transmit end interrupt enable bit
tie_icier		.btequ		7,icier		; Transmit interrupt enable bit
;
;-------------------------------------------------------
;   SS status register 
;-------------------------------------------------------
sssr			.equ		00bch
;
ce_sssr  		.btequ		0,sssr		; Conflict error flag
orer_sssr		.btequ		2,sssr		; Overrun error flag
rdrf_sssr		.btequ		5,sssr		; Receive data register ful
tend_sssr		.btequ		6,sssr		; Transmit end
tdre_sssr		.btequ		7,sssr		; Transmit data empty
;
;-------------------------------------------------------
;   IIC bus status register
;-------------------------------------------------------
icsr			.equ		00bch
;
adz_icsr  		.btequ		0,icsr		; General call address recognition flag
aas_icsr		.btequ		1,icsr		; Slave address recognition flag
al_icsr			.btequ		2,icsr		; Arbitration lost flag
stop_icsr		.btequ		3,icsr		; Stop condition detection flag
nackf_icsr		.btequ		4,icsr		; No acknowledge detection flag
rdrf_icsr		.btequ		5,icsr		; Receive data register full
tend_icsr		.btequ		6,icsr		; Transmit end
tdre_icsr		.btequ		7,icsr		; Transmit data empty
;
;-------------------------------------------------------
;   SS mode register 2
;-------------------------------------------------------
ssmr2			.equ		00bdh
;
ssums_ssmr2		.btequ		0,ssmr2		; SSUA mode select bit
csos_ssmr2		.btequ		1,ssmr2		; SCS pin open drain output select bit
soos_ssmr2		.btequ		2,ssmr2		; SSO pin open drain output select bit
sckos_ssmr2		.btequ		3,ssmr2		; SSCK pin open drain output select bit
css0_ssmr2		.btequ		4,ssmr2		; SCS pin selsct bit
css1_ssmr2		.btequ		5,ssmr2		; SCS pin select bit
scks_ssmr2		.btequ		6,ssmr2		; SSCK pin select bit
bide_ssmr2		.btequ		7,ssmr2		; Bidirectional mode enable bit
;
;-------------------------------------------------------
;   Slave address register
;-------------------------------------------------------
sar				.equ		00bdh
;
fs_sar			.btequ		0,sar		; Format select bit
sva0_sar		.btequ		1,sar		; Slave address 6 to 0
sva1_sar		.btequ		2,sar		; 
sva2_sar		.btequ		3,sar		; 
sva3_sar		.btequ		4,sar		; 
sva4_sar		.btequ		5,sar		; 
sva5_sar		.btequ		6,sar		; 
sva6_sar		.btequ		7,sar		; 
;
;-------------------------------------------------------
;   SS transmit data register
;-------------------------------------------------------
sstdr			.equ		00beh		;
;
;-------------------------------------------------------
;   IIC bus transmit data register
;-------------------------------------------------------
icdrt			.equ		00beh		;
;
;-------------------------------------------------------
;   SS receive data register
;-------------------------------------------------------
ssrdr			.equ		00bfh		;
;
;-------------------------------------------------------
;   IIC bus receive data register
;-------------------------------------------------------
icdrr			.equ		00bfh		;
;
;-------------------------------------------------------
;   A-D registers ADi
;-------------------------------------------------------
ad				.equ		00c0h		; A-D register
adl				.equ		ad			;       Low
adh				.equ		ad+1		;       High
;
;-------------------------------------------------------
;   A-D control register2
;-------------------------------------------------------
adcon2			.equ		00d4h		; A-D control register 2
smp				.btequ		0,adcon2	; A-D conversion method select bit
;
;-------------------------------------------------------
;   A-D control register0
;-------------------------------------------------------
adcon0			.equ		00d6h		; A-D control register0
;
ch0				.btequ		0,adcon0	; Analog input pin select bit
ch1				.btequ		1,adcon0	;
ch2				.btequ		2,adcon0	;
md				.btequ		3,adcon0	; A-D operation mode select bit
adgsel0			.btequ		4,adcon0	; A-D input group select bit
adst			.btequ		6,adcon0	; A-D conversion start flag
cks0_adcon0 	.btequ		7,adcon0	; Frequency select bit0
;
;-------------------------------------------------------
;   A-D control register1
;-------------------------------------------------------
adcon1			.equ		00d7h		; A-D control register1
;
bits			.btequ		3,adcon1	; 8/10-bit mode select bit
cks1_adcon1 	.btequ		4,adcon1	; Frequency select bit1
vcut			.btequ		5,adcon1	; Vref connect bit
;
;-------------------------------------------------------
;	Port
;-------------------------------------------------------;
p0				.equ		00e0h		; Port P0
p0_0			.btequ		0,p0        ; Port P00 bit
p0_1			.btequ		1,p0        ; Port P01 bit
p0_2			.btequ		2,p0        ; Port P02 bit
p0_3			.btequ		3,p0        ; Port P03 bit
p0_4			.btequ		4,p0        ; Port P04 bit
p0_5			.btequ		5,p0        ; Port P05 bit
p0_6			.btequ		6,p0        ; Port P06 bit
p0_7			.btequ		7,p0        ; Port P07 bit
;
p1				.equ		00e1h		; Port P1
p1_0			.btequ		0,p1        ; Port P10 bit
p1_1			.btequ		1,p1        ; Port P11 bit
p1_2			.btequ		2,p1        ; Port P12 bit
p1_3			.btequ		3,p1        ; Port P13 bit
p1_4			.btequ		4,p1        ; Port P14 bit
p1_5			.btequ		5,p1        ; Port P15 bit
p1_6			.btequ		6,p1        ; Port P16 bit
p1_7			.btequ		7,p1        ; Port P17 bit
;
pd0				.equ		00e2h		; Port P0 direction register
pd0_0			.btequ		0,pd0       ; Port P00 direction bit
pd0_1			.btequ		1,pd0       ; Port P01 direction bit
pd0_2			.btequ		2,pd0       ; Port P02 direction bit
pd0_3			.btequ		3,pd0       ; Port P03 direction bit
pd0_4			.btequ		4,pd0       ; Port P04 direction bit
pd0_5			.btequ		5,pd0       ; Port P05 direction bit
pd0_6			.btequ		6,pd0       ; Port P06 direction bit
pd0_7			.btequ		7,pd0       ; Port P07 direction bit
;
pd1				.equ		00e3h		; Port P1 direction register
pd1_0			.btequ		0,pd1       ; Port P10 direction bit
pd1_1			.btequ		1,pd1       ; Port P11 direction bit
pd1_2			.btequ		2,pd1       ; Port P12 direction bit
pd1_3			.btequ		3,pd1       ; Port P13 direction bit
pd1_4			.btequ		4,pd1       ; Port P14 direction bit
pd1_5			.btequ		5,pd1       ; Port P15 direction bit
pd1_6			.btequ		6,pd1       ; Port P16 direction bit
pd1_7			.btequ		7,pd1       ; Port P17 direction bit
;
p3				.equ		00e5h		; Port P3
p3_1			.btequ		1,p3        ; Port P31 bit
p3_3			.btequ		3,p3        ; Port P33 bit
p3_4			.btequ		4,p3        ; Port P34 bit
p3_5			.btequ		5,p3        ; Port P35 bit
p3_6			.btequ		6,p3        ; Port P36 bit
p3_7			.btequ		7,p3        ; Port P37 bit
;
pd3				.equ		00e7h		; Port P3 direction register
pd3_1			.btequ		1,pd3       ; Port P31 direction bit
pd3_3			.btequ		3,pd3       ; Port P33 direction bit
pd3_4			.btequ		4,pd3       ; Port P34 direction bit
pd3_5			.btequ		5,pd3       ; Port P35 direction bit
pd3_6			.btequ		6,pd3       ; Port P36 direction bit
pd3_7			.btequ		7,pd3       ; Port P37 direction bit
;
p4				.equ		00e8h		; Port P4
p4_2			.btequ		2,p4        ; Port P42 bit
p4_5			.btequ		5,p4        ; Port P45 bit
p4_6			.btequ		6,p4        ; Port P46 bit
p4_7			.btequ		7,p4        ; Port P47 bit
;
p5				.equ		00e9h		; Port P5
p5_3			.btequ		3,p5        ; Port P53 bit
p5_4			.btequ		4,p5        ; Port P54 bit
;
pd4				.equ		00eah		; Port P4 direction register
pd4_5			.btequ		5,pd4       ; Port P45 direction bit
;
pd5				.equ		00ebh		; Port P5 direction register
pd5_3			.btequ		3,pd5       ; Port P53 direction bit
pd5_4			.btequ		4,pd5       ; Port P54 direction bit
;
;-------------------------------------------------------
;   Port select registers
;-------------------------------------------------------
pinsr1			.equ		00f5h		; Port select register 1
uart1sel0		.btequ		0,pinsr1	; Port TXD1/RXD1 switch bit
uart1sel1		.btequ		1,pinsr1	; Port TXD1/RXD1 switch bit
;
pinsr2			.equ		00f6h		; Port select register 2
trbosel			.btequ		6,pinsr2	; Port TRBO select bit
;
pinsr3			.equ		00f7h		; Port select register 3
trciocsel		.btequ		3,pinsr3	; Port TRCIOC select bit
trciodsel		.btequ		4,pinsr3	; Port TRCIOD select bit
;
;-------------------------------------------------------
;   Port mode register
;-------------------------------------------------------
pmr				.equ		00f8h
int1sel			.btequ		0,pmr       ; INT1 pin select bit
ssisel			.btequ		3,pmr       ; SSI pin select bit
u1pinsel		.btequ		4,pmr       ; TXD1 pin select bit
txd1sel			.btequ		5,pmr       ; Port/TXD1 pin select bit
txd1en			.btequ		6,pmr       ; TXD1/RXD1 pin select bit
iicsel			.btequ		7,pmr       ; SSU/IIC pin select bit
;
;-------------------------------------------------------
;   External input enable register
;-------------------------------------------------------
inten			.equ		00f9h
int0en			.btequ		0,inten		; INT0 input enable bit
int0pl			.btequ		1,inten		; INT0 input polarity select bit
int1en			.btequ		2,inten		; INT1 input enable bit
int1pl			.btequ		3,inten		; INT1 input polarity select bit
int3en			.btequ		6,inten		; INT3 input enable bit
int3pl			.btequ		7,inten		; INT3 input polarity select bit
;
;-------------------------------------------------------
;   INT input filter select register
;-------------------------------------------------------
intf			.equ		00fah
int0f0			.btequ		0,intf		; INT0 input filter select bit
int0f1			.btequ		1,intf		;
int1f0			.btequ		2,intf		; INT1 input filter select bit
int1f1			.btequ		3,intf		;
int3f0			.btequ		6,intf		; INT3 input filter select bit
int3f1			.btequ		7,intf		;
;
;-------------------------------------------------------
;   Key input enable register
;-------------------------------------------------------
kien			.equ		00fbh
ki0en			.btequ		0,kien		; KI0 input enable bit
ki0pl			.btequ		1,kien		; KI0 input polarity select bit
ki1en			.btequ		2,kien		; KI1 input enable bit
ki1pl			.btequ		3,kien		; KI1 input polarity select bit
ki2en			.btequ		4,kien		; KI2 input enable bit
ki2pl			.btequ		5,kien		; KI2 input polarity select bit
ki3en			.btequ		6,kien		; KI3 input enable bit
ki3pl			.btequ		7,kien		; KI3 input polarity select bit
;
;-------------------------------------------------------
;   Pull-up control registers
;-------------------------------------------------------
pur0			.equ		00fch		; Pull-up control register0
pu00			.btequ		0,pur0		; P00 to P03 pull-up
pu01			.btequ		1,pur0		; P04 to P07 pull-up
pu02			.btequ		2,pur0		; P10 to P13 pull-up
pu03			.btequ		3,pur0		; P14 to P17 pull-up
pu06			.btequ		6,pur0		; P31, P33 pull-up
pu07			.btequ		7,pur0		; P34 to P37 pull-up
;
pur1			.equ		00fdh		; Pull-up control register1
pu11			.btequ		1,pur1		; P45 pull-up
pu12			.btequ		2,pur1		; P53 pull-up
pu13			.btequ		3,pur1		; P54 pull-up
;
;-------------------------------------------------------
;   Port P1 drivability control register
;-------------------------------------------------------
p1drr			.equ		00feh		; Port P1 drivability control register
p1drr0			.btequ		0,p1drr		; P10 drive capacity
p1drr1			.btequ		1,p1drr		; P11 drive capacity
p1drr2			.btequ		2,p1drr		; P12 drive capacity
p1drr3			.btequ		3,p1drr		; P13 drive capacity
p1drr4			.btequ		4,p1drr		; P14 drive capacity
p1drr5			.btequ		5,p1drr		; P15 drive capacity
p1drr6			.btequ		6,p1drr		; P16 drive capacity
p1drr7			.btequ		7,p1drr		; P17 drive capacity
;
;------------------------------------------------------
;  Timer RA control register
;------------------------------------------------------
tracr			.equ		0100h
tstart_tracr	.btequ		0,tracr		; Timer RA count start bit
tcstf_tracr		.btequ		1,tracr		; Timer RA count status flag
tstop_tracr		.btequ		2,tracr		; Timer RA count forcible stop bit
tedgf_tracr		.btequ		4,tracr		; Active edge reception flag
tundf_tracr		.btequ		5,tracr		; Timer RA underflow flag
;
;------------------------------------------------------
;  Timer RA I/O control register
;------------------------------------------------------
traioc			.equ		0101h
tedgsel_traioc	.btequ		0,traioc	; TRAIO polarity switch bit
topcr_traioc	.btequ		1,traioc	; TRAIO output control bit
toena_traioc	.btequ		2,traioc	; TRAO output enable bit
tiosel_traioc	.btequ		3,traioc	; INT1/TRAIO select bit
tipf0_traioc	.btequ		4,traioc	; TRAIO input filter select bit
tipf1_traioc	.btequ		5,traioc	;
;
;------------------------------------------------------
;  Timer RA mode register
;------------------------------------------------------
tramr			.equ		0102h
tmod0_tramr		.btequ		0,tramr		; Timer RA operating mode select bit
tmod1_tramr		.btequ		1,tramr		; 
tmod2_tramr		.btequ		2,tramr		; 
tck0_tramr		.btequ		4,tramr		; Timer RA count source select bit
tck1_tramr		.btequ		5,tramr		; 
tck2_tramr		.btequ		6,tramr		; 
tckcut_tramr	.btequ		7,tramr		; Timer RA count source cutoff bit
;
;-------------------------------------------------------
;   Timer RA registers
;-------------------------------------------------------
trapre			.equ		0103h		; Timer RA prescaler register
;
tra				.equ		0104h		; Timer RA register
;
;-------------------------------------------------------
;   LIN control register
;-------------------------------------------------------
lincr			.equ		0106h
sfie_lincr		.btequ		0,lincr		; Synchronous field measurementcompleted interrupt enable bit
sbie_lincr		.btequ		1,lincr		; Synchronous break detection interrupt enable bit
bcie_lincr		.btequ		2,lincr		; Bus conflict detection interrupt enable bit
rxdsf_lincr		.btequ		3,lincr		; RxD0 input status flag
lstart_lincr	.btequ		4,lincr		; Synchronous Break detection start bit
sbe_lincr		.btequ		5,lincr		; RxD0 input unmasking timing select bit
mst_lincr		.btequ		6,lincr		; LIN operation mode setting bit
line_lincr		.btequ		7,lincr		; LIN operation start bit
;
;-------------------------------------------------------
;   LIN status register
;-------------------------------------------------------
linst			.equ		0107h
sfdct_linst		.btequ		0,linst		; Synchronous field measurementcompleted flag
sbdct_linst		.btequ		1,linst		; Synchronous break detection flag
bcdct_linst		.btequ		2,linst		; Bus collision detection flag
b0clr_linst		.btequ		3,linst		; SFDCT flag clear bit
b1clr_linst		.btequ		4,linst		; SBDCT flag clear bit
b2clr_linst		.btequ		5,linst		; BCDCT flag clear bit
;
;------------------------------------------------------
;  Timer RB control register
;------------------------------------------------------
trbcr			.equ		0108h
tstart_trbcr	.btequ		0,trbcr		; Timer RB count start bit
tcstf_trbcr		.btequ		1,trbcr		; Timer RB count status flag
tstop_trbcr		.btequ		2,trbcr		; Timer RB count forcible stop bit
;
;------------------------------------------------------
;  Timer RB one-shot control register
;------------------------------------------------------
trbocr			.equ		0109h
tosst_trbocr	.btequ		0,trbocr	; Timer RB one-shot start bit
tossp_trbocr	.btequ		1,trbocr	; Timer RB one-shot stop bit
tosstf_trbocr	.btequ		2,trbocr	; Timer RB one-shot status flag
;
;------------------------------------------------------
;  Timer RB I/O control register
;------------------------------------------------------
trbioc			.equ		010Ah
topl_trbioc		.btequ		0,trbioc	; Timer RB output level select bit
tocnt_trbioc	.btequ		1,trbioc	; Timer RB output switch bit
inostg_trbioc	.btequ		2,trbioc	; One-shot trigger control bit
inoseg_trbioc	.btequ		3,trbioc	; One-shot trigger polarity select bit
;
;------------------------------------------------------
;  Timer RB mode register
;------------------------------------------------------
trbmr			.equ		010Bh
tmod0_trbmr		.btequ		0,trbmr		; Timer RB operating mode select bit
tmod1_trbmr		.btequ		1,trbmr		; 
twrc_trbmr		.btequ		3,trbmr		; Timer RB write control bit
tck0_trbmr		.btequ		4,trbmr		; Timer RB count source select bit
tck1_trbmr		.btequ		5,trbmr		; 
tckcut_trbmr	.btequ		7,trbmr		; Timer RB count source cutoff bit
;
;-------------------------------------------------------
;   Timer RB registers
;-------------------------------------------------------
trbpre			.equ		010ch		; Timer RB prescaler register
;
trbsc			.equ		010dh		; Timer RB secondary register
;
trbpr			.equ		010eh		; Timer RB primary register
;
;------------------------------------------------------
;  Timer RE seconds data register / Timer RE counter data register
;------------------------------------------------------
tresec			.equ		0118h
sc00_tresec		.btequ		0,tresec	; 1st digit of seconds count bits
sc01_tresec		.btequ		1,tresec	; 
sc02_tresec		.btequ		2,tresec	; 
sc03_tresec		.btequ		3,tresec	; 
sc10_tresec		.btequ		4,tresec	; 2nd digit of seconds count bits
sc11_tresec		.btequ		5,tresec	; 
sc12_tresec		.btequ		6,tresec	; 
bsy_tresec		.btequ		7,tresec	; Timer RE busy flag
;
;------------------------------------------------------
;  Timer RE minutes data register / Timer RE compare data register
;------------------------------------------------------
tremin			.equ		0119h
mn00_tremin		.btequ		0,tremin	; 1st digit of minutes count bits
mn01_tremin		.btequ		1,tremin	; 
mn02_tremin		.btequ		2,tremin	; 
mn03_tremin		.btequ		3,tremin	; 
mn10_tremin		.btequ		4,tremin	; 2nd digit of minutes count bits
mn11_tremin		.btequ		5,tremin	; 
mn12_tremin		.btequ		6,tremin	; 
bsy_tremin		.btequ		7,tremin	; Timer RE busy flag
;
;------------------------------------------------------
;  Timer RE Hours Data Register
;------------------------------------------------------
trehr			.equ		011ah
hr00_trehr		.btequ		0,trehr		; 1st digit of hours count bits
hr01_trehr		.btequ		1,trehr		; 
hr02_trehr		.btequ		2,trehr		; 
hr03_trehr		.btequ		3,trehr		; 
hr10_trehr		.btequ		4,trehr		; 2nd digit of hours count bits
hr11_trehr		.btequ		5,trehr		; 
bsy_trehr		.btequ		7,trehr		; Timer RE busy flag
;
;------------------------------------------------------
;  Timer RE Days of Week Data Register
;------------------------------------------------------
trewk			.equ		011bh
wk0_trewk		.btequ		0,trewk		; Days of week count bits
wk1_trewk		.btequ		1,trewk		; 
wk2_trewk		.btequ		2,trewk		; 
bsy_trewk		.btequ		7,trewk		; Timer RE busy flag
;
;------------------------------------------------------
;  Timer RE control register1
;------------------------------------------------------
trecr1			.equ		011ch
tcstf_trecr1	.btequ		1,trecr1	; Timer RE count status flag
toena_trecr1	.btequ		2,trecr1	; TREO pin output enable bit
int_trecr1		.btequ		3,trecr1	; Interrupt request timing bit
trerst_trecr1	.btequ		4,trecr1	; Timer RE reset bit
pm_trecr1		.btequ		5,trecr1	; A.M. / P.M. bit
h12_h24_trecr1	.btequ		6,trecr1	; Operating mode select bit
tstart_trecr1	.btequ		7,trecr1	; Timer RE count start bit
;
;------------------------------------------------------
;  Timer RE control register2
;------------------------------------------------------
trecr2			.equ		011dh
seie_trecr2		.btequ		0,trecr2	; Periodic interrupt triggered every second enable bit
mnie_trecr2		.btequ		1,trecr2	; Periodic interrupt triggered every minute enable bit
hrie_trecr2		.btequ		2,trecr2	; Periodic interrupt triggered every hour enable bit
dyie_trecr2		.btequ		3,trecr2	; Periodic interrupt triggered every day enable bit
wkie_trecr2		.btequ		4,trecr2	; Periodic interrupt triggered every week enable bit
comie_trecr2	.btequ		5,trecr2	; Compare match interrupt enable bit
;
;------------------------------------------------------
;  Timer RE count source select register
;------------------------------------------------------
trecsr			.equ		011eh
rcs0_trecsr		.btequ		0,trecsr	; Count source select bit
rcs1_trecsr		.btequ		1,trecsr	; 
rcs2_trecsr		.btequ		2,trecsr	; 4-Bit counter select bit
rcs3_trecsr		.btequ		3,trecsr	; Real-Time clock mode select bit
rcs5_trecsr		.btequ		5,trecsr	; Clock output select bit
rcs6_trecsr		.btequ		6,trecsr	; 
;
;------------------------------------------------------
;  Timer RC mode register
;------------------------------------------------------
trcmr			.equ		0120h		; Timer RC mode register
pwmb_trcmr		.btequ		0,trcmr		; TRCIOB PWM mode select bit
pwmc_trcmr		.btequ		1,trcmr		; TRCIOC PWM mode select bit
pwmd_trcmr		.btequ		2,trcmr		; TRCIOD PWM mode select bit
pwm2_trcmr		.btequ		3,trcmr		; PWM2 mode select bit
bfc_trcmr		.btequ		4,trcmr		; TRCGRC register function selection bit
bfd_trcmr		.btequ		5,trcmr		; TRCGRD register function selection bit
tstart_trcmr	.btequ		7,trcmr		; TRC count start bit
;
;------------------------------------------------------
;  Timer RC control register 1
;------------------------------------------------------
trccr1			.equ		0121h		; Timer RC control register 1
toa_trccr1		.btequ		0,trccr1	; TRCIOA output level select bit
tob_trccr1		.btequ		1,trccr1	; TRCIOB output level select bit
toc_trccr1		.btequ		2,trccr1	; TRCIOC output level select bit
tod_trccr1		.btequ		3,trccr1	; TRCIOD output level select bit
tck0_trccr1		.btequ		4,trccr1	; Count source selection bit
tck1_trccr1		.btequ		5,trccr1	; Count source selection bit
tck2_trccr1		.btequ		6,trccr1	; Count source selection bit
cclr_trccr1		.btequ		7,trccr1	; TRC counter clear select bit
;
;------------------------------------------------------
;  Timer RC interrupt enable register
;------------------------------------------------------
trcier			.equ		0122h		; Timer RC interrupt enable register
imiea_trcier	.btequ		0,trcier	; Input capture / compare match interrupt enable bit A
imieb_trcier	.btequ		1,trcier	; Input capture / compare match interrupt enable bit B
imiec_trcier	.btequ		2,trcier	; Input capture / compare match interrupt enable bit C
imied_trcier	.btequ		3,trcier	; Input capture / compare match interrupt enable bit D
ovie_trcier		.btequ		7,trcier	; Overflow / underflow interrupt enable bit
;
;------------------------------------------------------
;  Timer RC status register
;------------------------------------------------------
trcsr			.equ		0123h		; Timer RC status register
imfa_trcsr		.btequ		0,trcsr		; Input capture / compare match flag A
imfb_trcsr		.btequ		1,trcsr		; Input capture / compare match flag B
imfc_trcsr		.btequ		2,trcsr		; Input capture / compare match flag C
imfd_trcsr		.btequ		3,trcsr		; Input capture / compare match flag D
ovf_trcsr		.btequ		7,trcsr		; Overflow flag
;
;------------------------------------------------------
;  Timer RC I/O contorol register 0
;------------------------------------------------------
trcior0			.equ		0124h		; Timer RC I/O contorol register 0
ioa0_trcior0	.btequ		0,trcior0	; TRCGRA control bit
ioa1_trcior0	.btequ		1,trcior0	; 
ioa2_trcior0	.btequ		2,trcior0	; TRCGRA mode selection bit
iob0_trcior0	.btequ		4,trcior0	; TRCGRB control bit
iob1_trcior0	.btequ		5,trcior0	; 
iob2_trcior0	.btequ		6,trcior0	; TRCGRB mode selection bit
;
;------------------------------------------------------
;  Timer RC I/O contorol register 1
;------------------------------------------------------
trcior1			.equ		0125h		; Timer RC I/O contorol register 1
ioc0_trcior1	.btequ		0,trcior1	; TRCGRC control bit
ioc1_trcior1	.btequ		1,trcior1	; 
ioc2_trcior1	.btequ		2,trcior1	; TRCGRC mode selection bit
iod0_trcior1	.btequ		4,trcior1	; TRCGRD control bit
iod1_trcior1	.btequ		5,trcior1	; 
iod2_trcior1	.btequ		6,trcior1	; TRCGRD mode selection bit
;
;------------------------------------------------------
;  Timer RC counter register
;------------------------------------------------------
trc				.equ		0126h		; Timer RC counter register
;
;------------------------------------------------------
;  Timer RC general registers
;------------------------------------------------------
trcgra			.equ		0128h		; Timer RC general register A
;
trcgrb			.equ		012ah		; Timer RC general register B
;
trcgrc			.equ		012ch		; Timer RC general register C
;
trcgrd			.equ		012eh		; Timer RC general register D
;
;------------------------------------------------------
;  Timer RC control register 2
;------------------------------------------------------
trccr2			.equ		0130h		; Timer RC control register 2
csel_trccr2		.btequ		5,trccr2	; Timer RC operating mode select bit
tceg0_trccr2	.btequ		6,trccr2	; TRCTRG input edge selection bit
tceg1_trccr2	.btequ		7,trccr2	; TRCTRG input edge selection bit
;
;------------------------------------------------------
;  Timer RC digital filter function selection register
;------------------------------------------------------
trcdf			.equ		0131h		; Timer RC digital filter function selection register
dfa_trcdf		.btequ		0,trcdf		; TRCIOA pin digital filter function selection bit
dfb_trcdf		.btequ		1,trcdf		; TRCIOB pin digital filter function selection bit
dfc_trcdf		.btequ		2,trcdf		; TRCIOC pin digital filter function selection bit
dfd_trcdf		.btequ		3,trcdf		; TRCIOD pin digital filter function selection bit
dftrg_trcdf		.btequ		4,trcdf		; TRCIOG pin digital filter function selection bit
dfck0_trcdf		.btequ		6,trcdf		; Clock selection bit for digital filter function
dfck1_trcdf		.btequ		7,trcdf		; 
;
;------------------------------------------------------
;  Timer RC output master enable register
;------------------------------------------------------
trcoer			.equ		0132h		; Timer RC output master enable register
ea_trcoer		.btequ		0,trcoer	; TRCIOA output disable bit
eb_trcoer		.btequ		1,trcoer	; TRCIOB output disable bit
ec_trcoer		.btequ		2,trcoer	; TRCIOC output disable bit
ed_trcoer		.btequ		3,trcoer	; TRCIOD output disable bit
pto_trcoer		.btequ		7,trcoer	; INT0 of pulse output forced cutoff signal input enabled bit
;
;
;------------------------------------------------------
;  Flash mamory control register4
;------------------------------------------------------
fmr4			.equ		01b3h
;
fmr40			.btequ		0,fmr4		; Erase-suspend function enable bit
fmr41			.btequ		1,fmr4		; Erase-suspend request bit
fmr42			.btequ		2,fmr4		; Program-suspend request bit
fmr43			.btequ		3,fmr4		; Erase command flag
fmr44			.btequ		4,fmr4		; Program command flag
fmr46			.btequ		6,fmr4		; Read status flag
fmr47			.btequ		7,fmr4		; Low-Power consumption read mode enable bit
;
;------------------------------------------------------
;  Flash mamory control register1
;------------------------------------------------------
fmr1			.equ		01b5h
;
fmr11			.btequ		1,fmr1		; EW1 mode select bit
fmr15			.btequ		5,fmr1		; Block0 rewrite disable bit
fmr16			.btequ		6,fmr1		; Block1 rewrite disable bit
;
;------------------------------------------------------
;  Flash mamory control register0
;------------------------------------------------------
fmr0			.equ		01b7h
;
fmr00			.btequ		0,fmr0		; RY/BY status flag
fmr01			.btequ		1,fmr0		; CPU rewrite mode select bit
fmr02			.btequ		2,fmr0		; Block0 and 1 rewrite enable bit
fmstp			.btequ		3,fmr0		; Flash memory stop bit
fmr06			.btequ		6,fmr0		; Program status flag
fmr07			.btequ		7,fmr0		; Erase status flag
;
