/*******************************
  sci.c

  H8		SCI
  ---------------------------
  P21		RXD
  P22		TXD
 *******************************/
#include	"uart0.h"

#define		SCI_RX_BUF_SHIFT	3
#define		SCI_RX_BUF_SIZE		(1<<SCI_RX_BUF_SHIFT)
#define		SCI_RX_BUF_MASK		(SCI_RX_BUF_SIZE-1)

unsigned char RXbuff[10];             //10oCg
unsigned char RXid = 0;               // 1oCg
unsigned char RXcnt = 0;              // 1oCg
unsigned char v14,v15,v21,v22;        // 4oCg1oCg~4    0`255
  signed char vv14;



struct tdSCI_RX{
    u16 stIdx;
    u16 edIdx;
    u16 dataNum;
    u8 buf[SCI_RX_BUF_SIZE];
};

volatile static struct tdSCI_RX SCI_RX;

/*********************************
  VAʐMW[̏
 *********************************/
void SCI_init(void)
{
    SCR3 = 0x00;	/* TEARENA@CKE */
    SMR  = 0x00;	/* A8rbgApeBȂAXgbv1rbg n=0 */
    BRR  = 12;		/* 38400bps */
    SCR3 = 0x70;	/* RIE TE RE */
    PMR1 |= 0x02;	/* TXD |[gCl[u */
}

/**********************************
  M荞
 **********************************/
#pragma interrupt
void int_sci3(void)
{
    u8 int_flag, c;

    /* 荞݃tO̎擾ƃNA */
    int_flag = SSR;
    SSR = int_flag & ~0x38;	/* OER FER PER */

    /* Mobt@ɋ󂫗LȂM */
    if(int_flag & 0x04){	/* RDRF */
        c = RDR;
        if(SCI_RX.dataNum != SCI_RX_BUF_SIZE){
            SCI_RX.buf[SCI_RX.edIdx] = c;
            SCI_RX.edIdx = (SCI_RX.edIdx + 1) & SCI_RX_BUF_MASK;
            SCI_RX.dataNum++;
        }
    }
}

/**********************************
  PoCgM
 **********************************/
s32 SCI_read(s32 *c)
{

    /* Mobt@Ƀf[^Ύo */
    if(SCI_RX.dataNum != 0){
        *c = SCI_RX.buf[SCI_RX.stIdx];
        *c &= 0xFF;
        SCI_RX.stIdx = (SCI_RX.stIdx + 1) & SCI_RX_BUF_MASK;
        SCI_RX.dataNum--;
        return 1;
    }

    /* Mobt@Ȃ牽ȂŏI */
    *c = 0;
    return 0;
}

/*********************************
  PoCgM
 *********************************/
s32 SCI_write(s32 c)
{
    u32 i;
    u16 f;
    
    /* MWX^󂭂܂Ń|[Oő҂*/
    f=0;
    for(i=0; i<0x00200000; i++){
        if(SSR & 0x80){		/* TDRE */
            f=1;
            break;
        }
    }

    if(f){
        /* Mobt@ɏ */
        TDR = c & 0xFF;
        return 1;
    }
    return 0;
}

/**********************************

  ȍ~͔ėp֐
  n[hEFAɈˑȂ

 **********************************/

/**********************************
  P\
 **********************************/
s32 SCI_putchar(s32 c)
{
    /* sCR+LFɕϊđM */
    if(c == '\n'){
        if(!SCI_write(0x0D))
            return(0);
        if(!SCI_write(0x0A))
            return 0;
    }

    /* ȊO͂̂܂ܑM */
    else{
        if(!SCI_write(c))
            return 0;
    }

    return 1;
}

/**********************************
  \
 **********************************/
static s32 printStr(const u8 *str)
{
    const u8 *s;
    
    /* I[܂1\ */
    for(s=str; *s != '\0'; s++)
        if(!SCI_putchar(*s))
            return 0;

    /* \Ԃ */
    return (s - str);
}

/**********************************
  \(Ōɉst)
 **********************************/
s32 SCI_puts(const u8 *str)
{
    s32 len;

    /* \ */
    len = printStr(str);
    
    /* Ōɉs\ */
    SCI_putchar('\n');

    return (len + 1);
}

/**********************************
  w肳ꂽtH[}bgŕ\
 **********************************/
static void printFmt(u8 *p, u16 order, u16 alignLeft, u16 fillZero, u16 minus)
{
    u8 *s = p;
    u8 pad = ' ';
    u16 len = 0;
    s32 i;

    /* ̃JEg */
    for(len=0; *s != '\0'; len++, s++);
    
    /* }CiXȂ當 */
    if(minus)
        len++;

    /* ̒ */
    if(order){
        if(order > len){
            order -= len;
        }else{
            order = 0;
        }
    }

    /* El */
    if( ! alignLeft){
        /* lߕ̐ݒ */
        if(fillZero){
            pad = '0';
            
            /* }CiX\ */
            if(minus){
                SCI_putchar('-');
                minus = 0;
            }
        }

        for(i=0; i<order; i++)
            SCI_putchar(pad);
    }

    /* }CiX\ */
    if(minus)
        SCI_putchar('-');

    /* f[^̕\ */
    printStr(p);

    /* l */
    if(alignLeft)
        for(i=0; i<order; i++)
            SCI_putchar(' ');
}

/**********************************
  tH[}bg߂
 **********************************/
static const u8 *parseFmt(const u8 *s, void *value)
{
    u8 buf[12];
    u8 *p = buf;
    u16 alignLeft = 0;
    u16 fillZero = 0;
    u16 order = 0;
    u16 minus = 0;
    
    /* l */
    if(*s == '-'){
        alignLeft = 1;
        s++;
    }

    /* [tB */
    if(*s == '0'){
        fillZero = 1;
        s++;
    }

    /* w蔻 */
    if(isDec(*s)){
        for(order = 0; isDec(*s); ){
            order *= 10;
            order += (*s - '0');
            s++;
        }
    }

    /* ޔA\ */
    switch (*s){
    case 'd':	/* t10i */
        /* ̔ */
        if((s32)value >= 0){
            uint2Dec((u32)value, buf);
        }else{
            uint2Dec((u32)(-(s32)value), buf);
            minus = 1;
        }
        break;
    case 'u':	/* 10i */
        uint2Dec((u32)value, buf);
        break;
    case 'x':	/* 16i */
        uint2Hex((u32)value, 0, buf);
        break;
    case 'X':	/* 啶16i */
        uint2Hex((u32)value, 1, buf);
        break;
    case 's':	/*  */
        p = (u8*)value;
        break;
    case 'c':	/* P */
        buf[0] = (u8)((u32)value & 0xFF);
        buf[1] = '\0';
        break;
    default:
        buf[0] = '\0';
        break;
    }
    
    /* \ */
    printFmt(p, order, alignLeft, fillZero, minus);

    s++;
    return(s);
}

/**********************************
   printf
 **********************************/
s32 SCI_printf(const u8 *str, ... )
{
    va_list ap;
    const u8 *s;

    /* ψ̏ */
    va_start(ap, str);

    for(s = str; *s != '\0'; ){
        /* ꕶ */
        if(*s == '%'){
            s++;

            /* "%%"Ȃ'%'\ */
            if(*s == '%'){
                SCI_putchar('%');
                s++;
            }
            /* tH[}bgɏ]ĕ\ */
            else{
                s = parseFmt(s, va_arg(ap, void *));
                if(s == NULL)
                    return -1;
            }
        }

        /* 1ʂɕ\ */
        else{
            SCI_putchar(*s);
            s++;
        }
    }

    va_end(ap);
    return(s - str);
}

/**********************************
  PM
 **********************************/
s32 SCI_getchar(void)
{
    s32 c;
    
    /* f[^M܂ő҂ */
    while(!SCI_read(&c));

    /* sϊ */
    if(c == 0x0D)
        c = '\n';
    return c;
}

/**********************************
  PM(f[^҂Ȃ)
 **********************************/
s32 SCI_getchar2(void)
{
    s32 c;
    
    /* f[^M */
    SCI_read(&c);

    /* sϊ */
    if(c == 0x0D)
        c = '\n';
    return c;
}

/**********************************
  sM
 **********************************/
u8 *SCI_gets(u8 *s)
{
    s32 i = 0;
    s32 c;

    /* s܂ŎM */
    while((c = SCI_getchar()) != '\n'){
        s[i] = c;
        i++;
        SCI_putchar(c);		/* GR[obN */
    }

    /* sNULLɕϊ */
    s[i] = '\0';

    return s;
}

